<template src="./template.html"></template>

<script lang="ts">
import {
  Component,
  getModule,
  Prop,
  Vue,
  Watch,
} from "nuxt-property-decorator";
import { api } from "~/common/constaint";
import { redirectPage } from "~/utils/apiHanlers";
import { apiErrorHandler } from "~/utils/apiHanlers";
@Component({
  components: {
    EmptyData: () => import("@/components/Utils/EmptyData/index.vue"),
  },
})
export default class RecentMarketingComponent extends Vue {
  @Prop()
  loadingTableRecent!: boolean;

  get tab() {
    return this.$store.state.home.tab;
  }

  set tab(value: number) {
    this.$store.commit("home/setTab", value);
  }

  get listRecent() {
    return this.$store.state.home.listRecent;
  }
  set listRecent(item: any) {
    this.$store.commit("home/setListRecent", item);
  }

  convertImage(url: string) {
    return `${api}/${url}`;
  }

  password = "";
  isHidePassword = false;
  dialogPassword = false;

  urlLink = "";
  checkAdminPassword() {
    this.password = "";
    const isPasswordAdmin = localStorage.getItem("isPasswordAdmin");
    if (!isPasswordAdmin) {
      this.dialogPassword = true;
      return false;
    }
    return true;
  }

  onSetPassword() {
    if (!this.password)
      return this.$pushNotification.error("Please enter password");
    if (this.password === "zshopoverview2023@@!*") {
      this.$store.commit("product/checkIsCorrectPassword", true);
      localStorage.setItem("isPasswordAdmin", this.password);
      this.dialogPassword = false;
      this.$pushNotification.success("Correct password");
      this.$router.push(this.urlLink);
    } else {
      this.$pushNotification.error("Incorrect password");
    }
  }

  goToViewProduct(storeId: string) {
    this.urlLink = `/seller/store/${storeId}`;
    const isCheck = this.checkAdminPassword();
    if (!isCheck) return;
    this.$router.push(this.urlLink);
  }

  goToEditProduct(storeId: string) {
    this.urlLink = `/seller/store/${storeId}?tab=2`;
    const isCheck = this.checkAdminPassword();
    if (!isCheck) return;
    this.$router.push(this.urlLink);
  }

  sortViewContent = false;
  sortAddToCart = false;
  sortCheckOut = false;
  sortRevenue = false;
  sortPurchase = false;
  sortProductCost = false;
  sortConversionRate = false;
  sortGoCheckout = false;

  onSortTableLowToHigh(insert: string) {
    this.$store.commit("home/onSort", {
      key: insert,
      tab: this.tab,
      sortType: "lowToHigh",
      ctx: this,
    });
    this.checkValueSort(insert);
  }

  checkValueSort(insert: string) {
    this.sortGoCheckout = insert === "goCheckout";
    this.sortViewContent = insert === "viewContent";
    this.sortAddToCart = insert === "addToCart";
    this.sortCheckOut = insert === "initiateCheckout";
    this.sortRevenue = insert === "revenue";
    this.sortPurchase = insert === "purchase";
    this.sortProductCost = insert === "productCost";
    this.sortConversionRate = insert === "conversionRate";
  }
  onSortTableHightToLow(insert: string) {
    this.$store.commit("home/onSort", {
      key: insert,
      tab: this.tab,
      sortType: "hightToLow",
      ctx: this,
    });
    if (insert == "goCheckout") {
      this.sortGoCheckout = false;
    }
    if (insert == "viewContent") {
      this.sortViewContent = false;
    }
    if (insert == "addToCart") {
      this.sortAddToCart = false;
    }
    if (insert == "initiateCheckout") {
      this.sortCheckOut = false;
    }
    if (insert == "revenue") {
      this.sortRevenue = false;
    }
    if (insert == "purchase") {
      this.sortPurchase = false;
    }
    if (insert == "productCost") {
      this.sortProductCost = false;
    }
    if (insert == "conversionRate") {
      this.sortConversionRate = false;
    }
  }
}
</script>

<style lang="scss" scoped>
td,
th {
  border: 1px solid #f1f5f9;
}
td {
  padding: 16px !important;
}
p {
  margin-bottom: 0;
}

// thead th {
//   position: -webkit-sticky;
//   position: sticky;
//   top: 0;
// }

// tbody th {
//   position: -webkit-sticky;
//   position: sticky;
//   left: 0;
// }

// thead th:first-child {
//   left: 0;
//   z-index: 2;
// }

// thead th {
//   background: #000;
//   color: #fff;
//   z-index: 1;
// }

// tbody th {
//   background: #fff;
//   border-right: 1px solid #ccc;

//   box-shadow: 1px 0 0 0 #ccc;
// }

// table {
//   border-collapse: collapse;
// }

// td,
// th {
//   padding: 0.5em;
// }
</style>
